# Copyright (c) 2014 Dave Love, Liverpool University
# The licence for this file is as for the package itself.

Name:		libtinythread++
Version:	1.1
Release:	2%{?dist}
Summary:	A fairly compatible subset of the C++11 thread management classes

Group:		System Environment/Libraries
License:	zlib
URL:		http://tinythreadpp.bitsnbites.eu/
Source0:	http://tinythreadpp.bitsnbites.eu/files/TinyThread++-%version-src.tar.bz2

BuildRequires:	gcc-c++
BuildRoot:      %{_tmppath}/hwloc-%version-%{release}-root-%(%{__id_u} -n)

%description
TinyThread++ implements a fairly compatible subset of the C++11
thread management classes.  It has minimal overhead -- most functions
generate compact inline code, and library includes a very fast user
space mutex class (fast_mutex).

%package	devel
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description	devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%prep
%setup -q -n TinyThread++-%version


%build
pushd source
c++ $CXXFLAGS -fPIC -shared -pthread -Wl,--as-needed -Wl,-soname,%name.so.1.0 -o %name.so.1.0 tinythread.cpp
popd

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%_libdir $RPM_BUILD_ROOT%_includedir
install source/%name.so.1.0 $RPM_BUILD_ROOT%_libdir
install -m 644 source/*.h $RPM_BUILD_ROOT%_includedir
ln -s %name.so.1.0 $RPM_BUILD_ROOT%_libdir/%name.so

%check
pushd test
make
./hello && ./fractal && test -f fractal.tga && ./test
popd

%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc README.txt
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root,-)
%doc doc
%{_includedir}/*
%{_libdir}/*.so


%changelog
* Wed Aug 27 2014 Dave Love <d.love@liverpool.ac.uk> - 1.1-2
- Build with -pthread and specify soname
- Install headers 0644

* Wed Jun  4 2014 Dave Love <d.love@liverpool.ac.uk> - 1.1-1
- Initial packaging
